
/* optimieren der Ermittlung der Spinkonfiguration next() */

#include <stdio.h>
#include <stdlib.h>

#define NN  16
#define F0(x) {printf(x);exit(1);}
#define tbase unsigned long
#define ulong unsigned long
#define zahl double
#define CM(JJ,tJ,tU)  JJ

int nu=NN/2,nd=NN/2+NN%2;
ulong  npa[NN+1][NN+1][NN+1];   /* tabellierte Fakultaeten	*/

zahl fak(int i){zahl r=1.0;int j;for(j=2;j<=i;j++)r*=j;return(r);}
ulong over(int n,int k){ ulong r;int jn,jk;
    if(k>=n || k<1 || n<1)return 1l;
    if(k>n/2)k=n-k;			/* over(n,k)=over(n,n-k) */
    jn=n-k+1;r=(ulong)jn;
    for(jk=2;jk<=k;jk++){jn++;r=(ulong)(((double)r*(double)jn)/jk);} 
    return r;}

ulong np(int o,int u,int d){ return(over(o+u+d,u)*over(o+d,d));}

void   paini(){ int a,b,c;
    for(a=0;a<=NN;a++)for(b=0;b<=NN;b++)
    for(c=0;c<=NN;c++)npa[a][b][c]=np(a,b,c);
    return;}
    
/* zahl der spinkonfigurationen(NN,nu,nd) -> n1 ohne Sym */
ulong numkonf(){ return(npa[NN-CM(1,1,0)*(nu+nd)][nu][nd]);}

/* -------------------------------------------- 
   
    (n aus m) code (n 1-bits + (m-n) 0-bits) => get code+1 (next)
 
     example:    1001001110   search last 01 sequence and count 1-bits
                      ^^^^^   last 01 sequence at kk=4 (after them k1=3 1-bits)
                 1001010011   01 changed to 10 
                        ^^^   and filled with 0-bits and k1-1 1-bits
                              kk=k1-1; k1=k1-1; if(k1==0) neu suchen
     nicht die schnellste variante   (listen?)
     tabelle: position der 1 bits                      
                                                                     1/sun
     speed 486DX-100 32er JJ: next: 136s/200M = 5m/600M  (276s old)   36 (28) 
                              ll1 :1400s/200M =50m/600M (2100s old)    6
                              l1[]: 140s/200M                        216 (faster)
                              {}  :  27s/200M   
 */   

inline tbase  ll12(ulong i){	/* getbasis from index 0..N1-1 */
    ulong t,*tab;tbase j;int iu,id;		/* tab[NN+1][NN+1] */
    j=0l;iu=nu;id=nd;tab=&(npa[0][iu-1][id]); /* iu,id must be > 0 */
    for(;;){ j<<=1;
     if(i<*tab){           if(!--iu)return(~((~j)<<id)); tab-=NN+1; }
     else { i-=*tab; j|=1; if(!--id)return( (( j)<<iu)); tab--; }
    }
  }
    
inline  tbase nex3(tbase kfg){		/* Nd==0 causes an error */
  int d;ulong i;
  for(d=~0,i=1l;!(kfg&i);i<<=1      );
  for(i<<=1    ; (kfg&i);i<<=1,d<<=1);
  if(i!=1l<<NN) return( ((kfg | i) & ~(i-1)) | (~d) );
  return(~(d<<1)); }

inline tbase next(tbase kfg){ 
  int i=1,d=0;if(kfg&1l)d++;
  while(i<NN){ 
    if((kfg>>i)&1l)d++;else if(d)break;
    if(++i==NN)return(~(~0l<<d));}
  return( (kfg & (~0l<<i)) | (1l<<i) | (~(~0l<<--d)) );}

inline tbase  ll1(ulong ii){	/* getbasis from index 0..N1-1 */
    ulong i,t;tbase j;int iu,id;
    j=0l;iu=nu;id=nd;i=ii+1l; /* if(NN!=nu+nd)F0("nu+nd != NN") */
    for(;;){
     if(iu>0){ if(i<=(t=npa[0][iu-1][id])){j=(j<<1)|0;iu--;continue;}i-=t;}
     /* else { j=(j<<id)|~((~0l)<<id);break; F A S T E R ???? } */
     if(id>0){ if(i<=(t=npa[0][iu][id-1])){j=(j<<1)|1;id--;continue;}i-=t;}
     break;}
    return(j);}
    
inline ulong ll2(tbase ii){	/* n-dimensionale Linkodierung */
/* Inp: Spinkonfiguration, Out: Index des Basiszustandes */
    ulong j=0l;int iu,id,i,i1;
    iu=nu;id=nd;if(NN!=nu+nd)F0("nu+nd != NN")
    for(i=NN-1;i>=0;i--){
      i1=1&(ii>>i);
      if(i1>0 && iu>0 && id>0)j+=npa[0][iu-1][id];
      if(i1==0)iu--;
      if(i1==1)id--;}
    return(j);}

ulong xx[1000000l];	/* 4MB */
int testspeed(){
   ulong i,j1,k,l,tc,t1,num,nmax;
   num=1000000l;nmax=numkonf();if(num>nmax)num=nmax;
   printf("# speed: ll1,next,nex3,xx[] num=%lu\n",num);
   for(i=0l;i<num;i++)xx[i]=ll1(i);			        /* ini array */
   for(i=0l;i<num;i++)if(xx[i]!=ll12(i))printf(" %ul",i);	    /* check */
   for(t1=l=0;l<~0l && t1<1000l;l++){ j1=0l;k=ll1(0l); /* short measure time */
     tc=clock();for(i=0l;i<num;i++){j1^=ll1(i);}     t1+=clock()-tc;
   }
   printf(" crc=%8lu l=%8lu*%lu clk=%8lu l/clk=%.1e\n",j1,l,num,t1,l/(double)t1);
   for(t1=l=0;l<~0l && t1<1000l;l++){ j1=0l;k=ll1(0l); /* short measure time */
     tc=clock();for(i=0l;i<num;i++){j1^=k=next(k);}  t1+=clock()-tc;
   }
   printf(" crc=%8lu l=%8lu*%lu clk=%8lu l/clk=%.1e\n",j1,l,num,t1,l/(double)t1);
   for(t1=l=0;l<~0l && t1<1000l;l++){ j1=0l;k=ll1(0l); /* short measure time */
     tc=clock();for(i=0l;i<num;i++){j1^=k=nex3(k);}  t1+=clock()-tc;
   }
   printf(" crc=%8lu l=%8lu*%lu clk=%8lu l/clk=%.1e\n",j1,l,num,t1,l/(double)t1);
   for(t1=l=0;l<~0l && t1<1000l;l++){ j1=0l;k=ll1(0l); /* short measure time */
     tc=clock();for(i=0l;i<num;i++){j1^=xx[i];}      t1+=clock()-tc;
   }
   printf(" crc=%8lu l=%8lu*%lu clk=%8lu l/clk=%.1e\n",j1,l,num,t1,l/(double)t1);
   return 0;}

int main(){
   paini();
   printf(" numkonf=%lu\n",numkonf());
   testspeed();
   return 0; }
